<template>
  <label :class="classes">
    <input class="mh-checkbox__checkbox-input" type="checkbox" :disabled="isDisabled" />
    <div class="mh-checkbox__checkbox" />
    <div class="mh-checkbox__label">
      {{ label }}
    </div>
  </label>
</template>

<script>
export default {
  name: 'MhCheckbox',

  props: {
    label: {
      type: String,
      default: ''
    },

    isDisabled: {
      type: Boolean,
      default: false
    }
  },

  computed: {
    classes() {
      const BASE_CLASS = 'mh-checkbox'

      return [BASE_CLASS, this.isDisabled && BASE_CLASS + '_is_disabled']
    }
  }
}
</script>

<style lang="scss" scoped>
$mh-checkbox: '.mh-checkbox';

#{$mh-checkbox} {
  display: flex;
  align-items: center;
  gap: 5px;
  cursor: pointer;

  &__checkbox {
    position: relative;
    width: 17px;
    height: 17px;
    border: 1px solid;
    border-radius: 5px;
    transition: 0.3s ease;

    &::before {
      content: '';
      position: absolute;
      left: 3px;
      top: 4px;
      display: none;
      border-left: 2px solid $darken;
      border-bottom: 2px solid $darken;
      width: 8px;
      height: 4px;
      transform: rotate(-45deg) scale(0);
      transition: 0.3s ease;
    }
  }

  &__label {
    line-height: 1;
    transition: color 0.3s ease;
  }

  &:hover {
    #{$mh-checkbox}__checkbox {
      border-color: lighten($darken, 30%);

      &::before {
        border-color: lighten($darken, 30%);
      }
    }

    #{$mh-checkbox}__label {
      color: lighten($darken, 30%);
    }
  }

  &__checkbox-input {
    display: none;

    &:checked ~ #{$mh-checkbox}__checkbox {
      &::before {
        display: block;
        transform: rotate(-45deg) scale(1);
        animation: jump 0.3s ease;
      }
    }
  }

  &_is_disabled {
    cursor: not-allowed;

    #{$mh-checkbox}__checkbox {
      border-color: lighten($darken, 30%);

      &::before {
        border-color: lighten($darken, 30%);
      }
    }

    #{$mh-checkbox}__label {
      color: lighten($darken, 30%);
    }
  }
}

@keyframes jump {
  0% {
    -webkit-transform: rotate(-45deg) scale(0);
  }
  50% {
    -webkit-transform: rotate(-45deg) scale(1.2);
  }
  100% {
    -webkit-transform: rotate(-45deg) scale(1);
  }
}
</style>
